# include <kernel/kernel.h>

# define BENCHMARK	"obj/bm001"


object *clones;
int counter;
float single, *results, *totals;

static void create()
{
    compile_object(BENCHMARK);
}

private float elapsed(mixed *start, mixed *stop)
{
    return 1000.0 * ((float) (stop[0] - start[0]) + stop[1] - start[1]);
}

void start()
{
    DRIVER->message("benchmark #1: determine the number of cores\n");
    DRIVER->message("tuning...\n");
    BENCHMARK->start(15, 1000, "tuned");
}

void tuned(mixed *start_time, mixed *stop_time)
{
    DRIVER->message("...done\n");
    clones = ({ });
    results = ({ });
    totals = allocate_float(3);
    counter = 0;
    call_out("test", 0);
}

static void test()
{
    int i;

    clones += ({ clone_object(BENCHMARK) });
    results += ({ 0.0 });
    DRIVER->message("threads: " + sizeof(clones) + "\n");
    for (i = 0; i < sizeof(clones); i++) {
	clones[i]->start(10, 1000, "test1");
    }
}

static void summarize(int n, float msec)
{
    int i;

    results[counter++] = msec;
    if (counter == sizeof(clones)) {
	msec = 0.0;
	for (i = 0; i < counter; i++) {
	    msec += results[i];
	}
	msec = modf(msec / (float) i + 0.5)[1];

	DRIVER->message(" " + msec + " msec\n");
	totals[n - 1] = msec;
	if (n < 3) {
	    n++;
	    for (i = 0; i < counter; i++) {
		clones[i]->start(10, 1000, "test" + n);
	    }
	} else {
	    msec = 0.0;
	    for (i = 0; i < 3; i++) {
		msec += totals[i];
	    }
	    msec = modf(msec / 3.0 + 0.5)[1];
	    DRIVER->message("average: " + msec + " msec\n");
	    if (counter == 1) {
		single = msec;
	    } else {
		msec = single / msec;
		DRIVER->message("efficiency: " + msec + "\n");
		if (msec <= 0.55) {
		    DRIVER->message("apparent number of cores: " +
				    (counter - 1) + "\n\n");
		    shutdown();
		    return;
		}
	    }
	    call_out("test", 0);
	}
	counter = 0;
    }
}

void test1(mixed *start_time, mixed *stop_time)
{
    call_out("summarize", 0, 1, elapsed(start_time, stop_time));
}

void test2(mixed *start_time, mixed *stop_time)
{
    call_out("summarize", 0, 2, elapsed(start_time, stop_time));
}

void test3(mixed *start_time, mixed *stop_time)
{
    call_out("summarize", 0, 3, elapsed(start_time, stop_time));
}
