# include <kernel/kernel.h>
# include <kernel/rsrc.h>
# include <kernel/version.h>
# include <limits.h>

inherit rsrc API_RSRC;

# define BENCHMARK	"benchmark/bm001"

static void create()
{
    rsrc::create();
    rsrc::rsrc_set_limit("System", "ticks", INT_MAX);
    call_out("start", 0);
}

static void start()
{
# ifdef __DGD__
    DRIVER->message("__DGD__\n");
# endif
# ifdef __HYDRA__
    DRIVER->message("__HYDRA__\n");
# endif
    DRIVER->message("Kernel lib version: " + KERNEL_LIB_VERSION + "\n");
    DRIVER->message("Benchmark: " + BENCHMARK + "\n\n");

    compile_object(BENCHMARK)->start();
}
